<?xml version="1.0" encoding="UTF-8"?>
<interface>
  <requires lib="gtk+" version="3.16"/>
  <template class="GtdTaskRow" parent="GtkListBoxRow">
    <property name="visible">True</property>
    <property name="activatable">True</property>
    <property name="selectable">False</property>
    <property name="halign">center</property>
    <property name="margin">3</property>
    <child>
      <object class="GtkRevealer" id="revealer">
        <property name="visible">True</property>
        <property name="can_focus">False</property>
        <property name="transition_type">slide-down</property>
        <property name="transition_duration">200</property>

        <child>
          <object class="GtkBox">
            <property name="visible">True</property>
            <property name="can_focus">False</property>
            <property name="orientation">vertical</property>

            <child>
              <object class="GtkBox">
                <property name="visible">True</property>
                <property name="can_focus">False</property>
                <property name="margin-end">5</property>
                <property name="margin-start">5</property>
                <property name="margin-top">5</property>
                <property name="margin-bottom">5</property>
                <property name="height-request">32</property>
                <property name="spacing">4</property>

                <!-- Box with DnD margin -->
                <child>
                  <object class="GtkBox" id="dnd_box">
                    <property name="visible">True</property>
                    <property name="can_focus">False</property>
                  </object>
                </child>

                <child>
                  <object class="GtkEventBox" id="dnd_event_box">
                    <property name="visible">True</property>
                    <signal name="button-press-event" handler="on_button_press_event_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-begin" handler="on_drag_begin_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-end" handler="on_drag_end_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-failed" handler="on_drag_failed_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="enter-notify-event" handler="on_mouse_over_dnd_event_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="leave-notify-event" handler="on_mouse_out_dnd_event_cb" object="GtdTaskRow" swapped="no" />
                    <child>
                      <object class="GtkImage" id="dnd_icon">
                        <property name="visible">True</property>
                        <property name="icon-name">open-menu-symbolic</property>
                        <property name="pixel-size">12</property>
                        <style>
                          <class name="dim-label" />
                        </style>
                      </object>
                    </child>
                  </object>
                </child>

                <!-- Done checkbutton -->
                <child>
                  <object class="GtkCheckButton" id="done_check">
                    <property name="visible">True</property>
                    <property name="can_focus">True</property>
                    <property name="receives_default">False</property>
                    <property name="halign">center</property>
                    <property name="valign">center</property>
                    <property name="vexpand">True</property>
                    <property name="draw_indicator">True</property>
                    <property name="margin-start">6</property>
                    <signal name="toggled" handler="on_complete_check_toggled_cb" object="GtdTaskRow" swapped="no" />
                  </object>
                </child>

                <child>
                  <object class="GtkEventBox" id="header_event_box">
                    <property name="visible">True</property>
                    <signal name="button-press-event" handler="on_button_press_event_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-begin" handler="on_drag_begin_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-end" handler="on_drag_end_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="drag-failed" handler="on_drag_failed_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="enter-notify-event" handler="on_mouse_over_event_cb" object="GtdTaskRow" swapped="no" />
                    <signal name="leave-notify-event" handler="on_mouse_out_event_cb" object="GtdTaskRow" swapped="no" />
                    <child>
                      <object class="GtkBox">
                        <property name="visible">True</property>
                        <property name="can_focus">False</property>

                        <!-- Task title entry -->
                        <child>
                          <object class="GtdExpandableEntry" id="title_entry">
                            <property name="visible">True</property>
                            <property name="hexpand">True</property>
                            <property name="halign">start</property>
                            <property name="width-chars">5</property>
                            <property name="propagate-natural-width">True</property>
                            <signal name="activate" handler="on_task_changed_cb" object="GtdTaskRow" swapped="yes" />
                            <signal name="notify::text" handler="on_task_changed_cb" object="GtdTaskRow" swapped="yes" />
                            <style>
                              <class name="title" />
                            </style>
                          </object>
                        </child>

                        <child>
                          <object class="GtkLabel" id="task_date_label">
                            <property name="visible">True</property>
                            <property name="can_focus">False</property>
                            <property name="xalign">1.0</property>
                            <property name="margin-start">6</property>
                            <style>
                              <class name="dim-label"/>
                            </style>
                          </object>
                        </child>
                        <child>
                          <object class="GtkLabel" id="task_list_label">
                            <property name="visible">False</property>
                            <property name="can_focus">False</property>
                            <property name="xalign">0</property>
                            <property name="max_width_chars">18</property>
                            <property name="ellipsize">middle</property>
                            <style>
                              <class name="dim-label"/>
                            </style>
                          </object>
                        </child>

                      </object>
                    </child>
                  </object>
                </child>

                <!-- Close button -->
                <child>
                  <object class="GtkButton" id="toggle_button">
                    <property name="visible">True</property>
                    <property name="can_focus">True</property>
                    <signal name="clicked" handler="on_toggle_active_cb" object="GtdTaskRow" swapped="no"/>
                    <style>
                      <class name="flat" />
                      <class name="close-button" />
                    </style>
                    <child>
                      <object class="GtkImage">
                        <property name="visible">True</property>
                        <property name="can-focus">False</property>
                        <property name="icon-name">pan-down-symbolic</property>
                      </object>
                    </child>
                  </object>
                </child>

              </object>
            </child>

            <!-- Edit Panel revealer -->
            <child>
              <object class="GtkRevealer" id="edit_panel_revealer">
                <property name="visible">True</property>
                <property name="can_focus">False</property>
                <property name="transition_type">slide-down</property>
                <property name="transition_duration">250</property>
                <child>
                  <object class="GtdEditPane" id="edit_panel">
                    <property name="visible">True</property>
                    <property name="can_focus">False</property>
                    <signal name="changed" handler="on_task_changed_cb" object="GtdTaskRow" swapped="yes" />
                    <signal name="remove-task" handler="on_remove_task_cb" object="GtdTaskRow" swapped="no" />
                  </object>
                </child>
              </object>
            </child>
          </object>
        </child>
      </object>
    </child>
  </template>
</interface>
